Description

http://bugs.ruby-lang.org/issues/show/7110 の変更の結果、CGI#header の挙動が 1.9 系と異なる挙動となっています。

2.0.0 は 100% 互換という方針だったと思うので、今の trunk の CGI#header は 1.9 系に戻して、新しい機能はメソッド名を header_tag

等にするか、変更自体を2.0.0リリース後にした方が良いと思います。

Related issues:

Related to Ruby - Bug #7110: CGI: Add support for HTML5 <header> tag Closed 10/05/2012

Associated revisions

Revision 8549059d7677bc005012e3002515ed8a29bcb7f9 - 11/07/2012 06:36 AM - Takeyuki FUJIOKA 

lib/cgi/core.rb: alias CGI#http_header to CGI#header .
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37535 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 8549059d - 11/07/2012 06:36 AM - Takeyuki FUJIOKA 

lib/cgi/core.rb: alias CGI#http_header to CGI#header .

[Bug #7286]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@37535 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/06/2012 03:45 PM - naruse (Yui NARUSE)

hsbt (Hiroshi SHIBATA) wrote:

http://bugs.ruby-lang.org/issues/show/7110 の変更の結果、CGI#header の挙動が 1.9 系と異なる挙動となっています。

2.0.0 は 100% 互換という方針だったと思うので、今の trunk の CGI#header は 1.9 系に戻して、新しい機能はメソッド名を header_tag

等にするか、変更自体を2.0.0リリース後にした方が良いと思います。

 100%互換とかただの根拠のない噂なので、あまり広めないでください！

#2 - 11/06/2012 04:24 PM - xibbar (Takeyuki FUJIOKA)

1. 現状のまま

2. HTML4以前の時のみ、CGI#headerの挙動を変える

3. HTML5の時のみ、CGI#headerの挙動を変える

うーむ。

#3 - 11/06/2012 04:38 PM - knu (Akinori MUSHA)

CGIのHTML出力機能を使っているスクリプトで cgi.header を使っているものは少なくないと思うので、この変更は痛いですね。

妥協案としては、3を採用しつつ、

ブロックが渡されていたらタグを出力する

および

他のタグ生成メソッドのブロック内ではタグを出力する

ようにしておいて、ブロックなしの呼出には（将来変わるかもしれないからhttp_headerを使えと）警告を入れるということでどうでしょう。
#4 - 11/06/2012 07:32 PM - mame (Yusuke Endoh)

- Status changed from Open to Assigned

問題報告ありがとうございます > 柴田さん

ちゃんと考えてなかったので見逃してました (Zachary Scott が文句言ってくれてたのに) 。

これはちょっとまずそうですね。今から cgi.rb で html5 書くユーザと、cgi.rb で

書かれたレガシーコードをメンテする可哀想なユーザ、多分後者の方が多いと思うので。

といいつつ、既存コードで CGI.new("html5").header って書かれてる可能性ってどのくらい

ありますかね。考えにくければ、以下のような感じにするのが素直じゃないでしょうか。

puts CGI.new         .header #=> "Content-Type: text/html" + deprecated 警告

puts CGI.new("html4").header #=> "Content-Type: text/html" + deprecated 警告

puts CGI.new("html5").header #=> " "

つまり xibbar さんの 3 ですが。

--

Yusuke Endoh mame@tsg.ne.jp

#5 - 11/06/2012 08:58 PM - xibbar (Takeyuki FUJIOKA)

ちょっと方針を誤解していたことと、やはりインパクトが大きいので、

３にするコードを書いてみて、英語圏の方に議論してくれている2人と

redmineでやりとりしてみましょうか。

#6 - 11/06/2012 09:12 PM - mame (Yusuke Endoh)

xibbar (Takeyuki Fujioka) wrote:

ちょっと方針を誤解していたことと、やはりインパクトが大きいので、

３にするコードを書いてみて、英語圏の方に議論してくれている2人と

redmineでやりとりしてみましょうか。

 いいと思います。よろしくおねがいします。

方針について余談ですが、「100% 互換」のスローガンは、機能の議論を加速させるのに大変役立ったと思っています。

しかし一般ユーザに対する売り文句としては、衆目を集めるメリットより、ちょっとしたことで失望させるデメリットの方が大きそうなので、あんまり声高に主張しないほうがいいんじゃないかと思っています。(preview1

のリリースアナウンスでも書いてません)

--

Yusuke Endoh mame@tsg.ne.jp

#7 - 11/07/2012 10:35 AM - xibbar (Takeyuki FUJIOKA)

CGI#http_headerを新設という方向は変えずに、

html4までは

alias :header :http_header

が効くようにして、

html5の時は、

CGI#headerが上書きされるような仕様にしておこうかと思います。

--- a/lib/cgi/core.rb

+++ b/lib/cgi/core.rb

@@ -171,6 +171,7 @@ class CGI

return buf

end

end # http_header()

alias :header :http_header

def _header_for_string(content_type) #:nodoc:

buf = ''

#8 - 11/07/2012 03:36 PM - xibbar (Takeyuki FUJIOKA)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100
This issue was solved with changeset r37535.

Hiroshi, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

lib/cgi/core.rb: alias CGI#http_header to CGI#header .
